library ac_dart.shelf_middleware;

import 'src/auth.dart';
export 'src/auth.dart' show getSessionContext;

import 'package:shelf/shelf.dart' as shelf;
import 'package:atlassian_connect_host/atlassian_connect_host.dart';
import 'dart:convert';
import 'dart:io';
import 'package:mustache/mustache.dart' as mustache;
import 'package:atlassian_connect_shelf/src/util.dart';

shelf.Middleware productHostAuthenticator(AcHostService hostService) =>
    new JwtAuthenticator(hostService).middleware;

shelf.Middleware sessionTokenAuthenticator(AcHostService hostService) =>
    new SessionTokenAuthenticator(hostService).middleware;

// TODO: this is not specific to connect. Look to move to third party lib
shelf.Handler moustacheFile(String path, 
                            { Map<String, String> templateVariables: const {},
                              bool includeHeaders : false, 
                              bool includeExtraParams: false}) {
  return (shelf.Request request) {
    final file = fileRelativeToAppRoot(path);
    return file.openRead().transform(const Utf8Decoder())
      .fold(new StringBuffer(), (sb, s) => sb..write(s))
      .then((StringBuffer sb) {
        final tv = <String, String>{}..addAll(templateVariables);
        if (includeHeaders
            || includeExtraParams) { // TODO: only untill extra params exist
          tv.addAll(request.headers);
        }
//        if (includeExtraParams) {
//          request.extraParams.forEach((k, v) {
//            if (v is String) {
//              tv[k] = v;
//            }
//          });
//        }
        final template = mustache.parse(sb.toString());
        final output = template.renderString(tv);
        return new shelf.Response.ok(output);
    });
  };

}

shelf.Handler staticFile(String path) {
//  new VirtualDirectory('../ui').
  return (shelf.Request request) {
    return new shelf.Response.ok(new File(path).openRead());
  };
}
